import java.awt.event.MouseEvent;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import org.lekan.graphics.GraphicsProgram;


/**
 * Here's an intro/review to using Java, and an intro to using the SGGraphics package.
 * 
 * Your task: build a simple drawing program that does, at the minimum, the following:
 *  (1) Buttons that lets you choose whether to draw an ellipse, a rectangle, a line, a rounded line, or a quadratic curve
 *  (2) When the program first starts, the main canvas should display a nice welcoming message and/or graphics.
 *  (3) As soon as the user starts drawing, this welcome message should disappear
 *  (4) To draw, click and drag the mouse. The shape should display as you are dragging.
 *  (5) When released, the shape will stay on the screen.
 *  (6) A clear button will clear everything on the screen.
 * 
 * @author Your Name(s) Here!
 *
 */
public class EPGYDraw extends GraphicsProgram implements Runnable{
	
	final int WIDTH = 800;
	final int HEIGHT = 600;
	final int PADDLEW = 25;
	final int PADDLEH = 75;
	final int BUFFER = 10;
	final int PADDLES = 5;
	final int RADIUS = 10;
	final double BALLS = 3;
	final double INCREASE = 1;
	
	int p2y = HEIGHT/2-PADDLEH/2;
	int p1y = HEIGHT/2-PADDLEH/2;
	boolean p1u, p1d, p2u, p2d = false;
	double ballY = HEIGHT/2 - RADIUS;
	double ballX = WIDTH/2 - RADIUS;
	double ballVX, ballVY = 0;
	int p1s = 0;
	int p2s = 0;
	int win = 7;
	boolean play = true;
	boolean ai = false;
	
	
	Thread thread;
	public static void main(String[] args) {
		new EPGYDraw();
	}
	
	
	
	/**
	 * Put any setup code here!
	 */
	@Override
	public void setup() {
		// TODO: SETUP!
		this.getFrame().setTitle("EPGYDraw!");
		thread = new Thread(this);
		thread.start();
		this.getFrame().setBackgroundColor(Color.BLACK);
		reset(0);
	}
	
	/**
	 * Put your program run code here! Most of your code should be in here.
	 */
	@Override
	
	public void keyPressed(KeyEvent e) {
		if(e.getKeyCode() == 87) p1u = true;
		if(e.getKeyCode() == 83) p1d = true;
		if(e.getKeyCode() == 38) p2u = true;
		if(e.getKeyCode() == 40) p2d = true;
	}
	
	public void keyReleased(KeyEvent e) {
		if(e.getKeyCode() == 87) p1u = false;
		if(e.getKeyCode() == 83) p1d = false;
		if(e.getKeyCode() == 38) p2u = false;
		if(e.getKeyCode() == 40) p2d = false;
	}
	
	public void run() {
		while(true){
			this.getFrame().clearGraphics();
			if(p1u)p1y-=PADDLES;
			else if(p1d)p1y+=PADDLES;
			if(!ai){
				if(p2u)p2y-=PADDLES;
				else if(p2d)p2y+=PADDLES;
			} else {
				if(p2y+PADDLEH/2 < ballY+RADIUS) p2y+=PADDLES;
				else p2y-=PADDLES;
			}
			if(p1y < 0) p1y = 0;
			else if(p1y > HEIGHT-PADDLEH) p1y = HEIGHT-PADDLEH;
			if(p2y < 0) p2y = 0;
			else if(p2y > HEIGHT-PADDLEH) p2y = HEIGHT-PADDLEH;
			ballX += ballVX;
			ballY += ballVY;
			if(ballVY == 0) ballVY = Math.random()*2*BALLS-BALLS;
			if(ballX < 0) reset(1);
			if(ballX > WIDTH-RADIUS*2) reset(2);
			if((p1s >= win || p2s >= win) && play) end();
			if(ballY < 0 || ballY > HEIGHT-RADIUS*2){
				ballVY = -ballVY;
				ballY += ballVY;
			}
			if(ballX < BUFFER + PADDLEW && ballY < p1y + PADDLEH && ballY + RADIUS*2 > p1y){
				ballVX = Math.abs(ballVX);
				double temp = ballVY;
				if(ballY-RADIUS < p1y){	ballVY = -Math.abs(ballVY);
				}else if(ballY + RADIUS*2 > p1y + PADDLEH){ ballVY = Math.abs(ballVY);
				} else if(ballX + ballVX < BUFFER + PADDLEW) ballVY *= -1;
				if(temp != ballVY) {
					ballVX += INCREASE;
					ballVY *= 1.4;
				}
			}
			if(ballX > WIDTH - BUFFER - PADDLEW - RADIUS*2 && ballY < p2y + PADDLEH && ballY + RADIUS*2 > p2y){
				ballVX = -Math.abs(ballVX);
				double temp = ballVY;
				if(ballY-RADIUS < p2y) ballVY = -Math.abs(ballVY);
				else if(ballY + RADIUS*2 > p2y + PADDLEH) ballVY = Math.abs(ballVY);
				else if(ballX - ballVX < WIDTH - BUFFER - PADDLEW) ballVY *= -1;
				if(temp != ballVY) {
					ballVX -= INCREASE;
					ballVY *= 1.4;
				}
			}
			if(play){
				this.getFrame().drawRect(BUFFER,p1y,PADDLEW,PADDLEH);
				this.getFrame().drawRect(WIDTH-BUFFER-PADDLEW,p2y,PADDLEW,PADDLEH);
				this.getFrame().drawEllipse((int)ballX, (int)ballY, RADIUS, RADIUS);
				this.getFrame().drawText(Integer.toString(p2s), 190, BUFFER*3);
				this.getFrame().drawText(Integer.toString(p1s), 600, BUFFER*3);
			}
			try {
				Thread.sleep(10);
		    }
		    catch (InterruptedException e) {}
		}
	}
	public void end(){
		play = false;
		this.getFrame().clearGraphics();
		this.getFrame().drawRect(BUFFER,p1y,PADDLEW,PADDLEH);
		this.getFrame().drawRect(WIDTH-BUFFER-PADDLEW,p2y,PADDLEW,PADDLEH);
		this.getFrame().drawEllipse((int)ballX, (int)ballY, RADIUS, RADIUS);
		this.getFrame().drawText(Integer.toString(p2s), 190, BUFFER*3);
		this.getFrame().drawText(Integer.toString(p1s), 600, BUFFER*3);
	}
	public void reset(int player){
		if(player == 1){
			p1s++;
			ballX = WIDTH/2-RADIUS;
			ballY = HEIGHT/2-RADIUS;
			ballVY = (Math.random()*2*BALLS-BALLS);
			ballVX = BALLS;
		} else if(player == 2){
			p2s++;
			ballX = WIDTH/2-RADIUS;
			ballY = HEIGHT/2-RADIUS;
			ballVY = (Math.random()*2*BALLS-BALLS);
			ballVX = -BALLS;
		} else {
			ballX = WIDTH/2-RADIUS;
			ballY = HEIGHT/2-RADIUS;
			if(Math.random() == 0)ballVX = -BALLS;
			else ballVX = BALLS;
			ballVY = 1.3;
		}
	}
}